##########################
# General module variables
##########################
variable "project" {
  description = "The name of the project"
  type        = string
}

variable "environment" {
  description = "The name of the environment"
  type        = string
}

variable "tags" {
  description = "Tags to be added to all reosurces that take it"
  type        = map(string)
  default     = {}
}

variable "cluster_name" {
  description = "The name of the cluster"
  type        = string
}

variable "files_path" {
  description = "The path to this module, relative to the root of the configuration. If set to empty string, will default to path.module"
  type        = string
  default     = "modules/kubernetes-extras/"
}


variable "pod_iam_policy_mode" {
  description = "The way IAM policies are assigned to pods that need it. Possible values are 'kube2iam' (will trigger the installation of kube2iam) or 'iam-oidc' (for clusters that support and have it enabled, will trigger creation of service accounts)."
  type        = string
  default     = "kube2iam"
}

variable "oidc_provider_url" {
  description = "The URL (without scheme) of the OpenID Connect provider of the cluster, required when `pod_iam_policy_mode = \"iam-oidc\"`"
  type        = string
  default     = ""
}

variable "autoscaler_iam_policy_arn" {
  description = "The ARN of the policy to assign to autoscaler, required when `install_autoscaler = true`"
  type        = string
  default     = ""
}

variable "config_output_path" {
  description = "Where to save files generated by this module"
  type        = string
  default     = "./"
}

variable "vpc_id" {
  default = ""
}

variable "worker_subnet_ids" {
  type    = list(string)
  default = []
}

variable "workers_iam_role_name" {
  default = ""
}

variable "worker_nodes_security_group_id" {
  default = ""
}

variable "hlem_release_force_update" {
  description = "Whether to have helm force an update when needed"
  type        = bool
  default     = true
}

variable "enable_kms_encyption" {
  description = "Whether to enable encryption at rest with a CMK"
  type        = bool
  default     = false
}

##########################
# Service install switches
##########################
variable "is_eks" {
  default = "false"
}

variable "install_datadog" {
  type    = bool
  default = false
}

variable "install_istio" {
  type    = bool
  default = false
}

variable "install_service_broker" {
  type    = bool
  default = false
}

variable "install_external_dns" {
  type    = bool
  default = false
}

variable "install_calico" {
  type    = bool
  default = false
}

variable "install_helm" {
  type    = bool
  default = true
}

variable "install_autoscaler" {
  type    = bool
  default = false
}

variable "install_dashboard" {
  type    = bool
  default = false
}

variable "install_metrics_server" {
  type    = bool
  default = true
}

variable "install_alb_ingress" {
  type    = bool
  default = false
}

variable "install_ec2_spot_termination_handler" {
  type    = bool
  default = false
}

variable "install_new_relic" {
  type    = bool
  default = false
}

variable "install_efs_provisioner" {
  type    = bool
  default = false
}

variable "install_aws_k8s_cni_metrics" {
  description = "Whether to install AWS CNI metrics, requires `is_eks = true`"
  type        = bool
  default     = false
}

variable "upgrade_aws_k8s_cni_plugin" {
  description = "Whether to upgrade AWS CNI plugin, requires `is_eks = true`"
  type        = bool
  default     = false
}

variable "install_prometheus" {
  type    = bool
  default = false
}

variable "install_prometheus_operator" {
  type    = bool
  default = false
}

variable "install_fluent_bit" {
  type    = bool
  default = false
}

variable "install_grafana" {
  type    = bool
  default = false
}

##################
# Service versions
##################
variable "kube2iam_helm_chart_version" {
  default = "2.0.1"
}

variable "datadog_helm_chart_version" {
  default = "1.31.4"
}

variable "tiller_container_image_tag" {
  default = "v2.15.2"
}

variable "autoscaler_helm_chart_version" {
  type    = string
  default = "6.0.0"
}

variable "autoscaler_container_image_tag" {
  type    = string
  default = "v1.14.6"
}

variable etcd_container_image_tag {
  type    = string
  default = "v3.2.26"
}

variable service_broker_helm_chart_version {
  type    = string
  default = "1.0.1"
}

variable service_catalog_helm_chart_version {
  type    = string
  default = "0.2.1"
}

variable external_dns_helm_chart_version {
  type    = string
  default = "2.9.3"
}

variable "alb_ingress_container_image_tag" {
  type    = string
  default = "v1.1.3"
}

variable "istio_helm_chart_version" {
  type    = string
  default = "1.4.6"
}

variable "istio_helm_values" {
  description = "Any additional Helm values to specify to Istio Helm release"
  type        = list(string)
  default     = []
}

variable "istio_container_image_tag" {
  type    = string
  default = "1.4.6"
}

variable prometheus_helm_chart_version {
  type    = string
  default = "9.1.2"
}

variable prometheus_operator_helm_chart_version {
  type    = string
  default = "8.7.0"
}


variable fluent_bit_helm_chart_version {
  type    = string
  default = "2.7.2"
}

variable grafana_helm_chart_version {
  type    = string
  default = "3.10.2"
}

#######################
# Service configuration
#######################
variable "datadog_api_key" {
  default = ""
}

variable "datadog_agent_namespace" {
  default = "kube-system"
}

variable "external_dns_domain_filters" {
  type        = string
  description = "String used to filter hosted zones where external dns shuold create records. Not needed unless install_external_dns = true"
  default     = ""
}

variable "external_dns_record_policy" {
  type    = string
  default = "upsert-only"
}

variable "nria_license_key" {
  type    = string
  default = ""
}

variable "cni_iam_role_name" {
  description = "The name of the IAM role to be assigned to the CNI plugin pods"
  type        = string
  default     = ""
}

variable "aws_k8s_cni_manifest_url" {
  description = "The url of the AWS k8s CNI plugin manifest"
  type        = string
  default     = "https://raw.githubusercontent.com/aws/amazon-vpc-cni-k8s/release-1.5.4/config/v1.5/aws-k8s-cni.yaml"
}

variable "aws_k8s_cni_manifest_file" {
  description = "The local path where the AWS k8s CNI plugin manifest is stored"
  type        = string
  default     = "aws-k8s-cni.yaml"
}

variable "aws_k8s_cni_calico_manifest_url" {
  description = "The url of the AWS k8s CNI calico config manifest"
  type        = string
  default     = "https://raw.githubusercontent.com/aws/amazon-vpc-cni-k8s/release-1.5.4/config/v1.5/calico.yaml"
}

variable "aws_k8s_cni_calico_manifest_file" {
  description = "The local path where the AWS k8s CNI calico config manifest is stored"
  type        = string
  default     = "aws-k8s-cni-calico.yaml"
}

variable "aws_k8s_cni_metrics_manifest_url" {
  description = "The url of the AWS k8s CNI metrics helper manifest"
  type        = string
  default     = "https://raw.githubusercontent.com/aws/amazon-vpc-cni-k8s/release-1.5/config/v1.5/cni-metrics-helper.yaml"
}

variable "aws_k8s_cni_metrics_manifest_file" {
  description = "The local path where the AWS k8s CNI metrics helper manifest is stored"
  type        = string
  default     = "aws-k8s-cni-metrics.yaml"
}

variable "service_broker_container_image_with_tag" {
  default = "awsservicebroker/aws-servicebroker:stable"
}

variable service_catalog_replicas {
  description = "How many replicas of the k8s service catalog controllerManager pod count"
  type        = number
  default     = 3
}

variable service_catalog_limits_memory {
  type    = string
  default = "400Mi"
}

variable service_catalog_requests_memory {
  type    = string
  default = "80Mi"
}

variable service_catalog_limits_cpu {
  type    = string
  default = "200m"
}

variable service_catalog_requests_cpu {
  type    = string
  default = "100m"
}

variable service_catalog_healthcheck_enabled {
  type    = bool
  default = false
}

variable service_catalog_use_custom_templates {
  description = "Whether to setup an S3 bucket with custom service templates"
  type        = bool
  default     = true
}

variable service_catalog_custom_template_path {
  description = "Path to a directory containing templates, leave empty to use the templates bundled with the module files"
  type        = string
  default     = ""
}

variable service_catalog_custom_templates_s3_bucket {
  description = "Whether to setup an S3 bucket with custom service templates, leave empty to have the bucket created by the module"
  type        = string
  default     = ""
}

variable "service_catalog_enable_async_binding" {
  description = "Whether to enable async binding"
  type        = bool
  default     = false
}

variable "alb_ingress_resource_limits_cpu" {
  description = "CPU limits for ALB Ingress controller"
  type        = string
  default     = "100m"
}

variable "alb_ingress_resource_limits_mem" {
  description = "Memory limits for ALB Ingress controller"
  type        = string
  default     = "128Mi"
}

variable "alb_ingress_resource_requests_cpu" {
  description = "CPU requested for ALB Ingress controller"
  type        = string
  default     = "100m"
}

variable "alb_ingress_resource_requests_mem" {
  description = "Memory requested for ALB Ingress controller"
  type        = string
  default     = "128Mi"
}

variable "istio_mtls_enabled" {
  description = "Whether to configure istio with mTLS enabled"
  type        = string
  default     = false
}

variable "istio_mtls_auto" {
  description = "Whether to configure istio with Automatic mTLS"
  type        = string
  default     = false
}

variable "istio_config_validation_enabled" {
  description = "Whether to disable istio's ValidatingWebhookConfiguration. It is handy to disable validation for upgrades and slow clusters (because of timeouts)."
  type        = bool
  default     = true
}

variable "istio_sidecar_injector_enabled" {
  description = "Whether to configure istio with sidecar injector"
  type        = bool
  default     = true
}

variable "istio_sidecar_injector_exclusion_label" {
  description = "A label that, when present on a resource, instructs isito not to inject a sidecar on that resource. See https://istio.io/docs/setup/additional-setup/sidecar-injection/#more-control-adding-exceptions"
  default     = "k8s-xtrs.osdevex.gitlab.com/istio-disable-sidecar"
}

variable "istio_alb_ingress_manifest_file" {
  description = "The local path where the Istio ALB Ingress manifest is stored"
  type        = string
  default     = "istio-alb-ingress.yaml"
}

variable "istio_alb_ingress_external_dns_name" {
  description = "External DNS name mapping to an ALB used for istio or alb ingress setup. Not needed unless install_alb = true or install_alb_ingress = true"
  default     = ""
}

variable "istio_alb_ingress_subnets" {
  type        = list(string)
  description = "List of subnets where alb controller can attached load balancers. Not needed unless install_alb = true or install_alb_ingress = true"
  default     = []
}

variable "istio_alb_ingress_helm_values" {
  description = "The text to be appended to the helm chart values supplied to the helm release"
  type        = string
  default     = ""
}

variable "istio_alb_ingress_logs_s3_bucket" {
  default = ""
}

variable "istio_alb_ingress_logs_s3_object_prefix" {
  default = ""
}

variable "istio_alb_ingress_logs_s3_enabled" {
  type    = bool
  default = false
}

variable "istio_alb_ingress_enable_cognito_auth" {
  type    = bool
  default = false
}

variable "istio_alb_ingress_cognito_user_pool_arn" {
  default = ""
}

variable "istio_alb_ingress_cognito_user_pool_default_client_id" {
  default = ""
}

variable "istio_alb_ingress_cognito_user_pool_custom_domain_name" {
  default = ""
}

variable "istio_alb_ingress_tls_certificate_arn" {
  type    = string
  default = ""
}

variable "istio_alb_ingress_security_group_ids" {
  type    = list(string)
  default = []
}

variable "istio_alb_ingress_target_type" {
  type    = string
  default = "ip"
}

variable "fluent_bit_elastic_search_host" {
  description = "The ElasticSearch hostname to configure as the fluent-bit backend"
  type        = string
  default     = ""
}

variable "fluent_bit_elastic_search_tls_port" {
  description = "The port number for TLS enabled connections to ElasticSearch"
  type        = number
  default     = 443
}

variable "tiller_deploy_namespace" {
  description = "The namespace where tiller-deploy is installed"
  type        = string
  default     = "kube-system"
}

variable "tiller_deploy_service_account_name" {
  description = "The name for the tiller-deploy service account"
  type        = string
  default     = "tiller"
}
variable "grafana_admin_password" {
  description = "Grafana admin password"
  type        = string
  default     = "admin"
}
variable "grafana_helm_values" {
  description = "Any additional Helm values to specify to Grafana"
  type        = list(string)
  default     = []
}
variable "prometheus_helm_values" {
  description = "Any additional Helm values to specify to Prometheus"
  type        = list(string)
  default     = []
}

variable "prometheus_operator_helm_values" {
  description = "Any additional Helm values to specify to Prometheus"
  type        = list(string)
  default     = []
}
##########################
# AWS variables
##########################
variable "aws_region" {
  description = "The AWS region where the cluster lives"
  type        = string
}

variable "aws_account_id" {
  description = "The id of the AWS account thay owns the cluster"
  type        = string
}

##############################
# Kubernetes cluster variables
##############################
variable "kubeconfig_file" {
  description = "The path to the kubeconfig file"
  type        = string
}
